import javax.microedition.rms.*;
import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;
import java.io.*;
public class WriteReadExample extends MIDlet implements CommandListener
{
  private Display display;
  private Alert alert;
  private Form form; 
  private Command exit; 
  private Command start;
  private RecordStore recordstore = null;
  public WriteReadExample()
  {
    display = Display.getDisplay(this);
    exit = new Command("Exit", Command.SCREEN, 1);
    start = new Command("Start", Command.SCREEN, 1);
    form = new Form("Record");
    form.addCommand(exit);
    form.addCommand(start);
    form.setCommandListener(this);
  }
  public void startApp()
  {
    display.setCurrent(form);
  }
  public void pauseApp()
  {
  }
  public void destroyApp( boolean unconditional )
  {
  }
  public void commandAction(Command command, Displayable displayable)
  {
    if (command == exit)
    {
      destroyApp(true);
      notifyDestroyed();
    }
    else if (command == start)
    {
      try
      {
       recordstore = RecordStore.openRecordStore(
                                   "myRecordStore", true );
      }
      catch (Exception error)
      {
        alert = new Alert("Error Creating", 
                        error.toString(), null, AlertType.WARNING); 
        alert.setTimeout(Alert.FOREVER); 
        display.setCurrent(alert);
      }
      try
      {
        String outputData = "First Record";
        byte[] byteOutputData = outputData.getBytes();
        recordstore.addRecord(byteOutputData, 0, 
                     byteOutputData.length);
      }
      catch ( Exception error)
      {
        alert = new Alert("Error Writing", 
                     error.toString(), null, AlertType.WARNING); 
        alert.setTimeout(Alert.FOREVER); 
        display.setCurrent(alert);
      }
      try
      {
        byte[] byteInputData = new byte[1]; 
        int length = 0;
        for (int x = 1; x <= recordstore.getNumRecords(); x++)
        {
          if (recordstore.getRecordSize(x) > byteInputData.length)
          {
            byteInputData = new byte[recordstore.getRecordSize(x)];
          }
          length = recordstore.getRecord(x, byteInputData, 0);
        }
          alert = new Alert("Reading", new String(byteInputData, 0, 
                          length), null, AlertType.WARNING); 
          alert.setTimeout(Alert.FOREVER); 
          display.setCurrent(alert); 


      }
      catch (Exception error)
      {
        alert = new Alert("Error Reading", error.toString(), 
                            null, AlertType.WARNING); 
        alert.setTimeout(Alert.FOREVER); 
        display.setCurrent(alert);
      }
      try
      {
        recordstore.closeRecordStore();
      }
      catch (Exception error)
      {
        alert = new Alert("Error Closing", error.toString(), 
                         null, AlertType.WARNING); 
        alert.setTimeout(Alert.FOREVER); 
        display.setCurrent(alert);
      }
      if (RecordStore.listRecordStores() != null)
      {
        try
        {
          RecordStore.deleteRecordStore("myRecordStore");
        }
        catch (Exception error)
        {
         alert = new Alert("Error Removing", error.toString(), 
                        null, AlertType.WARNING); 
         alert.setTimeout(Alert.FOREVER); 
         display.setCurrent(alert);
        }
      }      
    }
  }
}
